"""Petit script pour tester MPI et Jobqueue
"""

import os
from mpi4py import MPI
from thyrsis.simulation.jobqueue import JobQueue

comm = MPI.COMM_WORLD
rank = comm.Get_rank()

tmpdir = "/tmp"
nsamples = 10
sample_dirs = [os.path.join(tmpdir, "sample%05d"%(sample_idx+1))
    for sample_idx in range(nsamples)]

if MPI:
    MPI.COMM_WORLD.barrier()

for sample_dir in JobQueue(sample_dirs, MPI):

    if MPI:
        print("process", MPI.COMM_WORLD.Get_rank(), 'building', sample_dir)

